| IOLink C# 1.11.0

Loading...
Searching...
No Matches
Public Member Functions | Static Public Member Functions | Protected Member Functions | Protected Attributes | List of all members
IOLink.RandomAccessFactory Class Reference

A factory to create RandomAccess instances from various ressources. More...

Inheritance diagram for IOLink.RandomAccessFactory:

## Public Member Functions
| RandomAccessFactory (global::System.IntPtr cPtr, bool cMemoryOwn)
void | Dispose ()

## Static Public Member Functions
static global::System.Runtime.InteropServices.HandleRef | getCPtr (RandomAccessFactory obj)
static global::System.Runtime.InteropServices.HandleRef | swigRelease (RandomAccessFactory obj)
static RandomAccess | Allocate (uint size)
| Create an in-memory RandomAccess of given size.
static RandomAccess | CopyInMemory (RandomAccess randomAccess)
| Load given RandomAccess in memory. If storage is already an in-memory RandomAccess, return it (no copy are done).
static RandomAccess | MapFile (string filePath)
| Get an accessor from a file mapped in memory.
static unsafe RandomAccess | FromBuffer (byte[] buffer, uint size)
| Create a RandomAccess from given memory area.
static RandomAccess | OpenURIRead (Uri uri)
| Create a RandomAccess from given URI, opening URI in Read Only.
static RandomAccess | OpenHTTPRead (Uri uri, string method, HTTPHeaders headers)
| Create a RandomAccess from given HTTP URI, opening URI in Read Only. Requested HTTP server must support HTTP range requests.
static RandomAccess | ExtractRegion (RandomAccess src, uint offset)
| Creates an accessor to a subset of a RandomAccess.
static RandomAccess | ExtractRegion (RandomAccess src, uint offset, uint size)
| Creates an accessor to a subset of a RandomAccess.
static RandomAccess | FromStream (StreamAccess stream)
| Create a RandomAccess that will delegate to a StreamAccess.

## Protected Member Functions
virtual void | Dispose (bool disposing)

## Protected Attributes
bool | swigCMemOwn

## Detailed Description

A factory to create RandomAccess instances from various ressources.

## Member Function Documentation

## ◆ CopyInMemory()

static RandomAccess IOLink.RandomAccessFactory.CopyInMemory | ( | RandomAccess | randomAccess | ) |
| inline static

Load given RandomAccess in memory. If storage is already an in-memory RandomAccess, return it (no copy are done).

Exceptions

  InvalidArgument | if input randomAccess is null

## ◆ ExtractRegion() [1/2]

static RandomAccess IOLink.RandomAccessFactory.ExtractRegion | ( | RandomAccess | src,
|  | uint | offset
| ) |  |
| inline static

Creates an accessor to a subset of a RandomAccess.

Parameters

  src | The accessor to create the subset from
  offset | The offset from the start of the source accessor

Exceptions

  InvalidArgument | if input randomAccess is null
  Error | When offset is out of range.

## ◆ ExtractRegion() [2/2]

static RandomAccess IOLink.RandomAccessFactory.ExtractRegion | ( | RandomAccess | src,
|  | uint | offset,
|  | uint | size
| ) |  |
| inline static

Creates an accessor to a subset of a RandomAccess.

Parameters

  src | The accessor to create the subset from
  offset | The offset from the start of the source accessor
  size | The size of the subset.

Exceptions

  InvalidArgument | if input randomAccess is null
  Error | When the subset range is out of the source accessor range.

## ◆ FromBuffer()

static unsafe RandomAccess IOLink.RandomAccessFactory.FromBuffer | ( | byte[] | buffer,
|  | uint | size
| ) |  |
| inline static

Create a RandomAccess from given memory area.

The return DataAccess does not have the ownership of given buffer. You must carefully manage lifetime of each objects.

## ◆ FromStream()

static RandomAccess IOLink.RandomAccessFactory.FromStream | ( | StreamAccess | stream | ) |
| inline static

Create a RandomAccess that will delegate to a StreamAccess.

Exceptions

  InvalidArgument | if input stream is null

## ◆ MapFile()

static RandomAccess IOLink.RandomAccessFactory.MapFile | ( | string | filePath | ) |
| inline static

Get an accessor from a file mapped in memory.

Parameters

  filePath | The path to the file to map.

Returns
  A RandomAccess with read and write capabilities.

Exceptions

  Error | If the file does not exist already

## ◆ OpenHTTPRead()

static RandomAccess IOLink.RandomAccessFactory.OpenHTTPRead | ( | Uri | uri,
|  | string | method,
|  | HTTPHeaders | headers
| ) |  |
| inline static

Create a RandomAccess from given HTTP URI, opening URI in Read Only. Requested HTTP server must support HTTP range requests.

Parameters

  uri | The HTTP(S) URI to get.
  method | The HTTP request method.
  headers | The HTTP request headers.

## ◆ OpenURIRead()

static RandomAccess IOLink.RandomAccessFactory.OpenURIRead | ( | Uri | uri | ) |
| inline static

Create a RandomAccess from given URI, opening URI in Read Only.

If the URI scheme is 'file': creates a ReadRandomAccess using StreamAccessFactory::openFileRead(). If the URI scheme is 'http(s)': calls openHTTPRead(), using the GET method and no headers.

The documentation for this class was generated from the following file:

- Release/net/generated/RandomAccessFactory.cs